////////////////////////////////////////////////////////////////////////////////
//     24  Windows 95/98/NT
//         ,  
//      
// Copyright (c) 1998 L-Card Ltd.

#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include "e24api.h"

void main()
{
DWORD hCom;
DWORD dwError;
DWORD ret=0;
unsigned char data[5];

unsigned long i;
long ad_d;
BYTE pr,chn,tmr,err;
unsigned char tmp=0xF0;

// Initialize E24 board
   hCom=InitE24("COM2",B38400);
   printf("Init");

//    e24api.cpp    

   ConfigE24Chan((DWORD)hCom,INT_TEST,CODECALL);

   double freq;
   SetE24Rate((DWORD)hCom,2000,CODECALL,&freq);
   printf("%f",freq);
   SetGain((DWORD)hCom,KU1,AUTOCAL,CODECALL);

//    
   RefreshParam((DWORD)hCom,CODECALL);
   StopE24((DWORD)hCom);
   SetActiveChan((DWORD)hCom,CODECALL);

//     EEPROM 
//   SetEEPROMAddress(hCom,0);
//   SetEEPROMByte(hCom,0x3A);
//   SetEEPROMAddress(hCom,1);
//   SetEEPROMByte(hCom,0xFA);
//   SetEEPROMAddress(hCom,0);
//   SetEEPROMByte(hCom,0x1A);

//   StopE24(hCom);
//   SetEEPROMAddress(hCom,1);
//   SetEEPROMByte(hCom,0xFA);
//   SetEEPROMAddress(hCom,1);
//   BYTE bt;
//   GetEEPROMByte(hCom,&bt);
//   printf("\n Byte = %x",bt);

//   RefreshParam((DWORD)hCom,CODECALL);
//   StopE24(hCom);
//   SetActiveChan((DWORD)hCom,CODECALL);



//    ,     
   int cnt0=0,cnt1=0,cnt2=0,cnt3=0; i=0;
   while(!kbhit())
   {
      ReadComData(hCom,data,4);
      ConvertE24Block(hCom,data,4,&ad_d,&pr,&chn,&tmr,&err);
      switch(chn)
      {
      case 0: cnt0++;break;
      case 1: cnt1++;break;
      case 2: cnt2++;break;
      case 3: cnt3++;
      }
      i++;
//      if(i==10) {i=0; printf("\n 0= %d 1 = %d 2 = %d 3 = %d", cnt0, cnt1, cnt2, cnt3); }
      printf("\n ad= %12ld num = %d ret = %2d", ad_d, chn, err);
   }
//   printf("\n 0= %d 1 = %d 2 = %d 3 = %d", cnt0, cnt1, cnt2, cnt3);

//          e24.dat
   getch();
   getch();
   printf("\n Writing File ...");

   long fsize=1000;
   unsigned char *cdata=new char[fsize*4+1];
   short *fdata;
   HANDLE hFile,hMap;
   hFile=CreateFile("e24.dat",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_WRITE,
                          NULL,CREATE_ALWAYS,FILE_FLAG_RANDOM_ACCESS,NULL);
   if(hFile==INVALID_HANDLE_VALUE){ MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   hMap=CreateFileMapping(hFile,NULL,PAGE_READWRITE,0,fsize*2,NULL);
   if(hMap==NULL){MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   fdata=(short *)MapViewOfFile(hMap,FILE_MAP_WRITE,0,0,0);

//   10 
   for(i=0;i<4*fsize;i+=40){
   ReadComData(hCom,cdata+i,40);
   printf("\n Reading %d", i);}

//   
   for(i=0;i<fsize;i++) {ConvertE24Block(hCom,cdata+4*i,4,&ad_d,&pr,&chn,&tmr,&err); fdata[i]=short(ad_d>>8);
   printf("%d",ad_d); }

end:
   UnmapViewOfFile(fdata);
   CloseHandle(hMap);
   CloseHandle(hFile);
   delete[] cdata;

   getch();
   getch();
   FreeComPort(hCom);
}


