#include <windows.h>

////////////////////////////////////////
//   
#define MDIN0     0
#define MDIN1     1
#define EXT_TEST  2
#define INT_TEST  3

//     
#define CODECALL  0xF
#define CODEC0    1
#define CODEC1    2
#define CODEC2    4
#define CODEC3    8

//     
#define KU1    0
#define KU2    1
#define KU4    2
#define KU8    3
#define KU16   4
#define KU32   5
#define KU64   6
#define KU128  7

#define NORMAL    0
#define AUTOCAL   1
#define EXTCAL0   2
#define EXTCALM   3
#define FULLCAL   4
#define FONCAL    5
#define INTCAL0   6
#define INTCALM   7

// /  
#define DIGITAL_ON   1
#define DIGITAL_OFF  0

//      
#define B2400     0
#define B4800     1
#define B9600     2
#define B19200    3
#define B38400    4

int SendCommand( HANDLE hCom, BYTE cmd, WORD par, BYTE length);
int ConfigE24Chan(HANDLE hCom, BYTE mode, BYTE chan);
int SetGain(HANDLE hCom, BYTE gain, BYTE mode, BYTE chan);
int RefreshParam(HANDLE hCom, BYTE chan);
int SetActiveChan(HANDLE hCom, BYTE chan);
int DigitalFilter(HANDLE hCom, BYTE mode);
int ResetCounter(HANDLE hCom);
int ConfigE24COM(HANDLE hCom, BYTE baud);
double SetE24Rate(HANDLE hCom, WORD code, BYTE chan);
int SetEEPROMAddress(HANDLE hCom, BYTE Addr);
BYTE GetEEPROMByte(HANDLE hCom);
int SetEEPROMByte(HANDLE hCom, BYTE bt);
int ConvertE24Block(unsigned char *Buf, long *ad_data, unsigned long *t, int *p, int *chan);
int InitE24(HANDLE hCom);

