//   䨣஢ COM 
typedef struct _AUX_MODE_ {
	union {
		struct {
unsigned char len:
				2,	//  ᫮
	stop:
				1,	// 稥 ⮯ 
	parity:
				2,	// ஢ઠ ⭮
	stuck_parity:
				1,	// 䨪 ⭮
	en_break_ctl:
				1,	// ⠭ 뢠
	dlab:
				1;	// ⨯ 

		} ctl_word;
		char	ctl;	// ० 

	} ctl_aux;

	unsigned long baud;
} AUX_MODE;

extern int ComAddress;
int	Port = 0;
#include <stdio.h>
#include <conio.h>
#include <assert.h>
//#include "sysp.h"

int	TimeOut;
// ⥭ ﭨ COM 
void	aux_stat(AUX_MODE * mode, int port)
{
	unsigned long b;
	mode->ctl_aux.ctl = (char) inp(ComAddress+3);
	outp(ComAddress+3, mode->ctl_aux.ctl | 0x80);

	b = inp(ComAddress+1);
	b = b << 8;
	b += inp(ComAddress);

	switch (b) {
	case 1040:
		b = 110;
		break;
	case 768:
		b = 150;
		break;
	case 384:
		b = 300;
		break;
	case 192:
		b = 600;
		break;
	case 96:
		b = 1200;
		break;
	case 48:
		b = 2400;
		break;
	case 24:
		b = 4800;
		break;
	case 12:
		b = 9600;
		break;
	case 6:
		b = 19200;
		break;
	case 3:
		b = 38400;
		break;
	case 2:
		b = 57600;
		break;
	case 1:
		b = 115200;
		break;
	default:
		b = 0;
		break;
	}

	mode->baud = b;
	outp(ComAddress+3, mode->ctl_aux.ctl & 0x7f);
}
//  ﭨ COM 
void	aux_init(AUX_MODE * mode, int port, int imask)
{
	unsigned div;
	char	ctl;
	switch (mode->baud) {
	case 110:
		div = 1040;
		break;
	case 150:
		div = 768;
		break;
	case 300:
		div = 384;
		break;
	case 600:
		div = 192;
		break;
	case 1200:
		div = 96;
		break;
	case 2400:
		div = 48;
		break;
	case 4800:
		div = 24;
		break;
	case 9600:
		div = 12;
		break;
	case 19200:
		div = 6;
		break;
	case 38400:
		div = 3;
		break;
	case 57600:
		div = 2;
		break;
	case 115200:
		div = 1;
		break;
	default:
		return (-1);
	}

	ctl = inp(ComAddress+3);
	outp(ComAddress+3, ctl | 0x80);

	outp(ComAddress+1, (div >> 8) & 0xff);
	outp(ComAddress, div & 0xff);

	outp(ComAddress+3, mode->ctl_aux.ctl & 0x7f);


	outp(ComAddress+1, imask);

	return (0);
}
// 뢮 ᨬ  COM 
void	aux_outp(char chr, int port)
{
	unsigned status_reg, out_reg;
	long	l = 0;
	status_reg = ComAddress+5;
	out_reg = status_reg - 5;
	while ((inp(status_reg) & 0x20) == 0 && ++l < 10000);
	if (l >= 10000)
		assert(l < 10000);
	outp(out_reg, chr);
}
clear_aux()
{
	unsigned status_reg, inp_reg;
	long	l = 0;
	char	c;
	status_reg = ComAddress+5;
	inp_reg = status_reg - 5;
	while ((inp(status_reg) & 1) == 1 && ++l < 10000)
		inp(inp_reg);
	inp(inp_reg);
}
//  ᨬ १ COM 
char	aux_inp(int port)
{
	unsigned status_reg, inp_reg;
	long	l = 0;
	char	c;
	status_reg = ComAddress+5;
	inp_reg = status_reg - 5;
	while ((inp(status_reg) & 1) == 0 && ++l < 100000L);
	if (l >= 100000L) {
		TimeOut = 1;
	}
	c = (inp(inp_reg));
	return c;
}

int	GetPortUart()
{
	unsigned status_reg, inp_reg, port;
	long	l = 0;
	char	c;
	port = Port;

	status_reg = ComAddress+5;
	inp_reg = status_reg - 5;
	c = (inp(inp_reg));
	return (c & 0xff);
}
//  ᨬ १ COM 
char	aux_inp_wait(int port)
{
	unsigned status_reg, inp_reg;
	long	l = 0;
	char	c;
	status_reg = ComAddress+5;
	inp_reg = status_reg - 5;
	while ((inp(status_reg) & 1) == 0 && ++l < 1000000L);
	if (l >= 1000000L) {
		TimeOut = 1;
	}
	c = (inp(inp_reg));
	return c;
}


AuxLenArray[] = {
	5, 6, 7, 8
};
AuxStopArray[] = {
	1, 2
};

AUX_MODE amd;
PutChar(int byte)
{
	aux_outp(byte, Port);
	delay(10);
}
PutSpeedChar(int byte)
{
	aux_outp(byte, Port);
}
GetChar()
{
	char	c;
	int	base;
	return aux_inp(Port);
}
GetCharWait()
{
	char	c;
	int	base;
	return aux_inp_wait(Port);
}
InitCom2(int com_number)
{
	Port = com_number;
	aux_stat(&amd, com_number);
	amd.baud = 19200;
	amd.ctl_aux.ctl_word.len = 3;
	amd.ctl_aux.ctl_word.stop = 0;
	amd.ctl_aux.ctl_word.parity = 0;
	amd.ctl_aux.ctl_word.stuck_parity = 0;
	aux_init(&amd, Port, 0);
}
InvertByte(char byte)
{
	int	i, n;
	for (i = n = 0; i < 8; i++, byte >>= 1)
		n |= (byte & 1) << (7 - i);
	return n;
}
NewBaud(long new_baud)
{
	aux_stat(&amd, Port);
	amd.baud = new_baud;
	aux_init(&amd, Port, 0);
}
