////////////////////////////////////////////////////////////////////////////////
//     24  Windows 95/98/NT
//         ,  
//      
// Copyright (c) 1998 L-Card Ltd.

#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include "e24api.h"

void main()
{
HANDLE hCom;
DWORD dwError;
DWORD ret=0;
unsigned char data[7];

unsigned long tmr;
long ad_d;
int pr,chn;
unsigned char tmp=0xF0;
//   
   hCom = CreateFile("COM2", GENERIC_READ | GENERIC_WRITE,
                      0,               // comm devices must be opened w/exclusive-access
                      NULL,            // no security attrs
                      OPEN_EXISTING,   // comm devices must use OPEN_EXISTING
                      0,               // not overlapped I/O
                      NULL             // hTemplate must be NULL for comm devices
                    );

   if (hCom == INVALID_HANDLE_VALUE)
      {
         dwError = GetLastError();
         printf("Last error %d",dwError);
      }

//  
   InitE24(hCom);

//    e24api.cpp    
   SetActiveChan(hCom,CODEC0);
   ConfigE24Chan(hCom,MDIN0,CODECALL);

   DigitalFilter(hCom,DIGITAL_OFF);
   double freq=SetE24Rate(hCom,500,CODECALL);
   SetGain(hCom,KU1,AUTOCAL,CODECALL);
//    
   RefreshParam(hCom,CODECALL);

//     EEPROM 
//   SetEEPROMAddress(hCom,0);
//   SetEEPROMByte(hCom,0x3A);
//   SetEEPROMAddress(hCom,1);
//   SetEEPROMByte(hCom,0xFA);
//   SetEEPROMAddress(hCom,0);
//   SetEEPROMByte(hCom,0x1A);

   SetEEPROMAddress(hCom,1);
   printf("%x", GetEEPROMByte(hCom));

   printf(" %f Hz",freq);
   getch();

   while(!kbhit())
   {
      ReadFile(hCom,&data,7,&ret,NULL);
      ConvertE24Block(data,&ad_d,&tmr,&pr,&chn);
      printf("\n ad= %12ld tmr = %12d num = %d ret = %2d", ad_d, tmr, chn, ret);
   }

   printf("\n Writing File ...");

   long fsize=1000;
   int i;
   unsigned char *cdata=new char[fsize*7];
   short *fdata;
   HANDLE hFile,hMap;
   hFile=CreateFile("e24.dat",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_WRITE,
                          NULL,CREATE_ALWAYS,FILE_FLAG_RANDOM_ACCESS,NULL);
   if(hFile==INVALID_HANDLE_VALUE){ MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}
   hMap=CreateFileMapping(hFile,NULL,PAGE_READWRITE,0,fsize*2,NULL);
   if(hMap==NULL){MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}
   fdata=(short *)MapViewOfFile(hMap,FILE_MAP_WRITE,0,0,0);

   for(i=0;i<7*fsize;i+=70){
   ReadFile(hCom,cdata+i,70,&ret,NULL);
   printf("\n Reading %d", i);}

   for(i=0;i<fsize;i++) {ConvertE24Block(cdata+7*i,&ad_d,&tmr,&pr,&chn); fdata[i]=short(ad_d>>8);
   printf("%d",ad_d); }

end:
   UnmapViewOfFile(hMap);
   CloseHandle(hFile);
   delete[] cdata;

   getch();
   getch();
   CloseHandle(hCom);
}


