#include <time.h>
#include <alloc.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <math.h>
#include "ui_attr.h"
#include "e24_test.h"

char *InterLine="-----------------------------------------------------------------------\n";
char *ChanIndex[]={"᭮  (A)", "⥫  (B)",
				  "⪠", "⮢ ०"};
long ProgonPeriod=600;
double RmsLimit=3.5;

extern int TimeOut;
extern	NewBaud(long l);

double	CountRms(long *Array, int N, long *lptr);


double	Rms;
long	Rms0, Rms1, min, max;
int GainIndex[8]={1,2,4,8,16,32,64,128};
int	Pnl;
int	ChOn1, ChOn2, ChOn3, ChOn4;
int	COM_Port = 1;
long	Baud_Rate = 9600;
int	Parity = 0;
int	Data_Bits = 8;
int ComAddress=0x3F8;
int Mode = 1;
double FRate=10.0;
long	ChanAverData[1024];
int FilterOn=1;
int	Stop_Bits = 1;
int	Input_Queue_Size = 512;
int	Output_Queue_Size = 512;
int	Port_Address = 0;
int	Interrupt_Level = 0;
int	OutValue = 0xaa;
int	ComBaud;
int	N7714;
extern int rs232err;
int	EepromByte;
int	EepromAddress = 0;
int	Rate;
int	Gain, Chan;
int	ChanArray[] = {0, 1, 2, 3};
int	ChanOn;
int	ChanOnArray[] = {0xf, 1, 2, 4, 8};
int Ver;

long Errors[4];
double MaxRms[4];
long ProgonN;
int ProgonOn=0;
FILE *fp;
int	ComBase[] = {
	0x03F8,
	0x02F8,
	0x3220,
	0x3228,
	0x4220,
	0x4228,
	0x5220,
0x5228};


int	BoxAddress[] = {TEST_BOX1, TEST_BOX10, TEST_BOX11, TEST_BOX12};
long	BaudArray[] = {2400, 4800, 9600, 19200, 38400, 57600}, LBaud;
long	AdChData, T, P;
unsigned char Buf[2048];
long	AdData[500], AdCount = 0;
char	SerialStr[33] = "E-24, SEH-51324, Ver. 1.0";
int	N = 1024;
long	*ChanData[4];
int	ChanN[4], OldChanN[4];
int	ChanFirstN[4];
int GraphOn;
int GraphChan;
time_t t, t_new;
struct dostime_t t_start;
double RmsArray[4];
unsigned char	cstr[100];

main()
{
	unsigned long l, l1, l2, l3;
	int	i, j, k, n, key, hnd, cnt;
	unsigned int ii, jj;
	double	f;


	struct tm ti;

	gettime( &ti );
	i = ti.tm_sec;
	i = ti.tm_min;
	i = ti.tm_hour;
	i = ti.tm_mday;
	i = ti.tm_mon;
	i = ti.tm_year;
	i = ti.tm_wday;
	i = ti.tm_yday;
	i = ti.tm_isdst;
	OpenInterfaceManager();

	Pnl = LoadPanel("e24_test.uir", TEST);
	SetCtrlVal(Pnl, TEST_COMADDRESS, ComAddress);
	SetCtrlVal(Pnl, TEST_BAUD, ComBaud = 3);
	SetCtrlVal(Pnl, TEST_STRING, SerialStr);
	SetCtrlVal(Pnl, TEST_ADDRESS, EepromAddress);
	SetCtrlVal(Pnl, TEST_N_AD7714, 0);
	SetCtrlVal(Pnl, TEST_GAIN, 0);
	SetCtrlVal(Pnl, TEST_CHANNEL, 3);
	SetCtrlVal(Pnl, TEST_RATE, FRate);
	SetCtrlVal(Pnl, TEST_CH1, ChOn1 = 1);
	SetCtrlVal(Pnl, TEST_CH2, ChOn2 = 1);
	SetCtrlVal(Pnl, TEST_CH3, ChOn3 = 1);
	SetCtrlVal(Pnl, TEST_CH4, ChOn4 = 1);
	SetCtrlVal(Pnl, TEST_FILTER, FilterOn=1);
	SetCtrlVal(Pnl, TEST_MODE, Mode);
	SetCtrlVal( Pnl, TEST_NRMS, N );
	GraphWinInit();
	DisplayPanel(Pnl);

	for (i = 0; i < 4; i++)
		ChanData[i] = malloc(N * sizeof(long));
	if (ChanData[3] == NULL) {
		MessagePopup("No Memory");
		exit(1);
	}

	InitCom2(1);
	clear_aux();

	i = ComAddress + 4;
	j = inportb(i);
	j &= ~3;
	outportb(i, j);
	delay(400);
	j = inportb(i);
	j |= 2;
	j &= ~1;
	outportb(i, j);
	outportb(0x378, 0xFF);
	outportb(0x278, 0xFF);

	sleep(1);

	Init();

	sleep(1);
	if( !Diagnos_E24() )
	 {
	  MessagePopup( "E-24  ࠡ⠥ !!!");
	  exit(0);
	 }
	for (key = 0; !key;) {
		GetUserEvent(0, &hnd, &cnt);
		if (hnd == Pnl) {
			if(ProgonOn) cnt=TEST_PROGON;
			switch (cnt) {

			case TEST_NRMS:
				GetCtrlVal( Pnl, TEST_NRMS, &N );
				for (i = 0; i < 4; i++)
				  free(ChanData[i]);
				for (i = 0; i < 4; i++)
				  ChanData[i] = malloc(N * sizeof(long));
				for (i = 0; i < 4; i++) {
					ChanN[i] = 0;
					ChanFirstN[i] = 0;
				}
				break;

			case TEST_DONE:
				key = 1;
				break;

			case TEST_STOP:
				PutChar(0xFF);
				break;

			case TEST_READ:
				// Get Info
				PutSpeedChar(0xF5);
				for(j=0; j < 200; j++) if((unsigned char)GetCharWait() == 0xEE) break;
				if (j >= 32) break;
				if (TimeOut) break;

				for (n = 0; n < 13; n++) SerialStr[n] = GetCharWait();
				break;

			case TEST_FILTER:
				GetCtrlVal(Pnl, TEST_FILTER, &FilterOn);
				PutChar(0);
				PutChar(FilterOn & 0xF);
				PutChar(0xF4);
				for (i = 0; i < 4; i++) {
					ChanN[i] = 0;
					ChanFirstN[i] = 0;
				}
				break;

			case TEST_MODE:
				GetCtrlVal(Pnl, TEST_MODE, &Mode);
				break;

			case TEST_GIST:
				TestBitPnl();
				break;

			case TEST_PROGON:
				if(ProgonOn)
					{
					fputs(InterLine, fp);
					fprintf(fp, "\n\n᫮ ॢ襭 (RMS>%4.1f) : Ch1=%5lu  Ch2=%5lu  Ch3=%5lu  Ch4=%5lu\n\n",
					RmsLimit, Errors[0],Errors[1],Errors[2],Errors[3]);

					fprintf(fp, "ᨬ RMS : Ch1=%9.1f Ch2=%9.1f Ch3=%9.1f Ch4=%9.1f\n",
						MaxRms[0],MaxRms[1],MaxRms[2],MaxRms[3]);

					_dos_gettime(&t_start);
					fprintf(fp, "\n⠭ E-24 祭  : %2d:%02d\n",
							t_start.hour, t_start.minute);
					fclose(fp);
					ProgonOn=0;
					SetCtrlVal(Pnl, TEST_STATUS, "⠭ 祭");
					MessagePopup("ନ஢ ୠ ஢ 祭");
					break;
					}
				fp=fopen("e24_tst.log", "wt");
				if(fp == NULL) break;
				ProgonOn=1;
				ProgonN=0;
				ZeroArrays();

				fputs(InterLine, fp);
				_dos_gettime(&t_start);
				fprintf(fp, "⠭ E-24   : %2d:%02d\n\n",
						t_start.hour, t_start.minute);

				fputs(InterLine, fp);
				fprintf(fp, "ࠬ \n");
				fprintf(fp, " : %.0f \n", FRate);
				fprintf(fp, "ᨫ: %u\n", GainIndex[Gain]);
				fprintf(fp, " : %s\n", ChanIndex[N7714]);
				fprintf(fp, "  COM ⮬: %lu \n\n", BaudArray[ComBaud]);
				fputs(InterLine, fp);

				SetCtrlVal(Pnl, TEST_STATUS, "⠭ ");
				for(i=0; i < 4; i++) { Errors[i]=0; MaxRms[i]=0; }
				t = time(NULL);
				break;

			case TEST_TEST_C:
				break;

			case TEST_GRAPH:
				GraphWinInit();
				break;

			case TEST_CHAN:
				GetCtrlVal(Pnl, TEST_CHAN, GraphChan);
				DeletePlots (Pnl, TEST_STRIP);
				break;

			case TEST_SPEKTR:
				SpektrPanel();
				break;

			case TEST_COMADDRESS:
				GetCtrlVal(Pnl, TEST_COMADDRESS, &ComAddress);

				InitCom2(1);
				clear_aux();

				i = ComAddress + 4;
				j = inportb(i);
				j |= 2;
				j &= ~1;
				outportb(i, j);
				outportb(0x378, 0xFF);
				outportb(0x278, 0xFF);

				Init();
				break;


			case TEST_BAUD:
				GetCtrlVal(Pnl, TEST_BAUD, &ComBaud);

				// Set 0x5A
				PutChar((0x5A >> 4) & 0xF);
				PutChar(0x5A & 0xF);
				PutChar(0xE0 | ComBaud);

				LBaud = BaudArray[ComBaud];
				NewBaud(LBaud);
				break;

			case TEST_STRING:
				GetCtrlVal(Pnl, TEST_ADDRESS, &EepromAddress);
				GetCtrlVal(Pnl, TEST_STRING, SerialStr);

				// Set EEPROM Address
				PutChar((EepromAddress >> 4) & 0xF);
				PutChar(EepromAddress & 0xF);
				PutChar(0xF2);

				// Set EEPROM Byte
				for (i = 0; i < 32; i++) {
					j = SerialStr[i];
					PutChar((j >> 4) & 0xF);
					PutChar(j & 0xF);
					PutChar(0xF3);
					delay(10);
				}
				break;

			case TEST_READSTRING:
				GetCtrlVal(Pnl, TEST_ADDRESS, &EepromAddress);

				// Set EEPROM Address
				PutChar((EepromAddress >> 4) & 0xF);
				PutChar(EepromAddress & 0xF);
				PutChar(0xF2);

				// Get EEPROM Byte
				for (n = SerialStr[0] = 0; n < 32; n++) {
					PutSpeedChar(0xF1);
					j = 0;
					while (((i = GetCharWait()) & 0xF0) != 0xA0 && j++ < 32);
					if (j >= 32)
						break;
					if (TimeOut)
						break;
					j = GetCharWait();
					i = ((i & 0xF) | ((j & 0xF) << 4));
					SerialStr[n] = i;
				}
				SerialStr[n] = 0;
				SetCtrlVal(Pnl, TEST_STRING, SerialStr);
				break;

			case TEST_BYTE:
				GetCtrlVal(Pnl, TEST_ADDRESS, &EepromAddress);
				GetCtrlVal(Pnl, TEST_BYTE, &EepromByte);

				// Set EEPROM Address
				PutChar((EepromAddress >> 4) & 0xF);
				PutChar(EepromAddress & 0xF);
				PutChar(0xF2);

				// Set EEPROM Byte
				PutChar((EepromByte >> 4) & 0xF);
				PutChar(EepromByte & 0xF);
				PutChar(0xF3);

				delay(10);
				break;

			case TEST_READBYTE:
				GetCtrlVal(Pnl, TEST_ADDRESS, &EepromAddress);

				// Set EEPROM Address
				PutChar((EepromAddress >> 4) & 0xF);
				PutChar(EepromAddress & 0xF);
				PutChar(0xF2);

				// Read EEPROM Byte
				PutSpeedChar(0xF1);
				j = 0;
				while (((i = GetCharWait()) & 0xF0) != 0xA0 && j++ < 32);
				if (j >= 32)
					break;
				if (TimeOut)
					break;
				j = GetCharWait();
				EepromByte = ((i & 0xF) | ((j & 0xF) << 4));
				SetCtrlVal(Pnl, TEST_BYTE, EepromByte);
				break;

			case TEST_ZEROT:
				PutChar(0xF0);
				break;

			case TEST_CH1:
			case TEST_CH2:
			case TEST_CH3:
			case TEST_CH4:
				GetCtrlVal(Pnl, TEST_CH1, &ChOn1);
				GetCtrlVal(Pnl, TEST_CH2, &ChOn2);
				GetCtrlVal(Pnl, TEST_CH3, &ChOn3);
				GetCtrlVal(Pnl, TEST_CH4, &ChOn4);

				PutChar(0x80 | (ChOn1) | (ChOn2 << 1) |
					(ChOn3 << 2) | (ChOn4 << 3));
				break;

			case TEST_COMMAND_SEND:
				Init();

			case TEST_RESETRMS:
				for (i = 0; i < 4; i++) {
					ChanN[i] = 0;
					ChanFirstN[i] = 0;
				}
				break;

			default:
				break;

			}
		}
		else {
			long summ = 0;
			TimeOut = 0;
			clear_aux();
for (i = 0; i < 200; i++)
   {
	Buf[i] = GetCharWait();
	if (kbhit() || TimeOut) break;
   }
if (!TimeOut)
 {
  for (n = 0; n < 190; n++)
   {
    if( Ver == 1 )
     if ( !(Buf[n] & 0x80) || (Buf[n + 1] & 0x80) ||
	  (Buf[n + 2] & 0x80) || (Buf[n + 3] & 0x80) ||
	  (Buf[n + 4] & 0x80) || (Buf[n + 5] & 0x80) ||
	  (Buf[n + 6] & 0x80) ) continue;
    if( Ver == 2 )
     if ( !(Buf[n] & 0x80) || (Buf[n + 1] & 0x80) ||
	   (Buf[n + 2] & 0x80) || (Buf[n + 3] & 0x80) ) continue;
    if( Ver == 1 )
     {
      P = (Buf[n] & 0x40) >> 6;
      k = (Buf[n] >> 3) & 3;
      AdChData = (Buf[n] & 0x7) | ((unsigned long) Buf[n + 1] << 3L) |
		   ((unsigned long) Buf[n + 2] << 10L) |
		   ((unsigned long) Buf[n + 3] << 17L);
      T = (Buf[n + 4]) | ((unsigned long) Buf[n + 5] << 7L) |
	  ((unsigned long) Buf[n + 6] << 14L);
     }
    if( Ver == 2 )
     {
      P = (Buf[n] & 0x40) >> 6;
      k = (Buf[n] >> 4) & 3;
      AdChData = ((unsigned long) ( Buf[n] & 0x0F) << 20L |
		  ((unsigned long) Buf[n + 1] << 13L) |
		  ((unsigned long) Buf[n + 2] << 6L) |
		  ((unsigned long) Buf[n + 3] >> 1L));
     }
      AdChData -= 0x800000;

      // Handle Loop Array for RMS calculations
    ChanData[k][ChanN[k]] = AdChData;
    ChanN[k]++;
    if (ChanN[k] >= N)
     {
      ChanN[k] = 0;
      ChanFirstN[k] = N;
     }
    if (ChanFirstN[k] < N)
     ChanFirstN[k]++;
    if (ChanFirstN[k] < 10)
     continue;
    f=CountRms(ChanData[k], ChanFirstN[k], &l);
    sprintf(cstr, "%8ld %1lu %6.1f", AdChData, P, f);
    SetCtrlVal(Pnl, BoxAddress[k], cstr);
    RmsArray[k]=f;
    if (k == 0)
     {
      SetCtrlVal(Pnl, TEST_MIN1, min);
      SetCtrlVal(Pnl, TEST_MAX1, max);
     }
   }

				SetCtrlVal(Pnl, TEST_TIMER, T);
				SetCtrlVal(Pnl, TEST_N, ChanFirstN[0]);

				if(ProgonOn)
				 {
				 t_new = time(NULL);
				 if(t_new - t > ProgonPeriod)
					{
					sprintf(cstr, "⠭ 横 %lu, 訡 %lu", ++ProgonN,
									Errors[0]+Errors[1]+Errors[2]+Errors[3]);
					SetCtrlVal(Pnl, TEST_STATUS, cstr);
					t=t_new;
					_dos_gettime(&t_start);
					fprintf(fp, "%2d:%02d  Rms1=%9.1f, Rms2=%9.1f, Rms3=%9.1f, Rms4=%9.1f\n",
						t_start.hour, t_start.minute,
						RmsArray[0], RmsArray[1],RmsArray[2],RmsArray[3]);

					for(i=0; i < 4; i++)
						{
						if(RmsArray[i] > MaxRms[i]) MaxRms[i]=RmsArray[i];
						if(RmsArray[i] > RmsLimit) Errors[i]++;
						}

					ZeroArrays();
					}
				 }

				// Draw Char
				if(GraphOn && OldChanN[GraphChan] != ChanN[GraphChan])
					{
				  if(OldChanN[GraphChan] > ChanN[GraphChan])
						OldChanN[GraphChan]=0;
				  PlotStripChart (Pnl, TEST_STRIP,
							ChanData[GraphChan]+OldChanN[GraphChan],
							ChanN[GraphChan]-OldChanN[GraphChan], 0, 0, 2);
					OldChanN[n]=ChanN[n];
				  }
			}
			else
				SetCtrlVal(Pnl, TEST_STATUS, "㦥 Time Out");

		}
	}

	UnloadPanel(Pnl);
	CloseInterfaceManager();
	for (i = 0; i < 4; i++)
		free(ChanData[i]);

	// 몫稬  E-24
	i = ComAddress + 4;
	j = inportb(i);
	j &= ~3;
	outportb(i, j);
}

double	CountRms(long *Array, int N, long *lptr)
{
	int	i, j;
	double	f, ms, dx, rms;
	long	l;
	for (i = 0, min = 0xfffffff, max = 0; i < N; i++) {
		if (min > Array[i])
			min = Array[i];
		if (max < Array[i])
			max = Array[i];
	}
	*lptr = max - min;

	for (i = f = 0; i < N; i++)
		f += Array[i];
	f /= N;

	for (i = dx = 0; i < N; i++)
		dx += (Array[i] - f) * (Array[i] - f);
	dx /= (N - 1);
	dx = sqrt(dx);

	Rms0 = Array[N - 2];
	Rms1 = Array[N - 1];

//	dx *= 5E6 / (1L << 24L);

	return dx;
}


Init()
{
	int	i;
	double	f;
	GetCtrlVal(Pnl, TEST_N_AD7714, &N7714);
	ChanOn = ChanOnArray[N7714];
	GetCtrlVal(Pnl, TEST_GAIN, &Gain);
	GetCtrlVal(Pnl, TEST_CHANNEL, &i);
	Chan = ChanArray[i];
	GetCtrlVal(Pnl, TEST_RATE, &FRate);
	GetCtrlVal(Pnl, TEST_FILTER, &FilterOn);
	Rate = 2457600. / (FRate * 128.);

// Send Channel
	PutSpeedChar((Chan >> 4) & 0xF);
	PutSpeedChar(Chan & 0xF);
	PutSpeedChar(0x90 | ChanOn);

// SetFilter
	PutSpeedChar(0);
	PutSpeedChar(FilterOn & 0xF);
	PutSpeedChar(0xF4);

// Send Gain
	PutSpeedChar( Mode & 0xF );
	PutSpeedChar( Gain & 0xF );
	PutSpeedChar(0xC0 | ChanOn);

// Send Low Byte of Rate
	PutSpeedChar((Rate >> 4) & 0xF);
	PutSpeedChar(Rate & 0xF);
	PutSpeedChar(0xB0 | ChanOn);

// Send High Byte of Rate
	PutSpeedChar((Rate >> 12) & 0xF);
	PutSpeedChar((Rate >> 8) & 0xF);
	PutSpeedChar(0xA0 | ChanOn);

	PutSpeedChar(0xD0 | ChanOn);

	SetCtrlVal(Pnl, TEST_STATUS, " ᫠");
}


GraphWinInit()
{
int i, j;

GetCtrlVal(Pnl, TEST_GRAPH, &GraphOn);
j=(GraphOn) ? 1 : 0;
for(i=0; i < 4; i++) SetCtrlAttribute(Pnl, BoxAddress[i],ATTR_CTRL_HIDDEN,j);
SetCtrlAttribute(Pnl, TEST_STRIP, ATTR_CTRL_HIDDEN, !j);
DisplayPanel(Pnl);
DeletePlots (Pnl, TEST_STRIP);
}

ZeroArrays()
{
int i;

for (i = 0; i < 4; i++)
 {
	ChanN[i] = 0;
	ChanFirstN[i] = 0;
 }
}


UpdateArrays()
{
int	i, j, k, n, key, hnd, cnt;
unsigned int ii, jj;
unsigned long l, l1, l2, l3;
double	f;

TimeOut = 0;
clear_aux();
for (i = 0; i < 200; i++)
   {
	Buf[i] = GetCharWait();
	if (kbhit() || TimeOut) break;
   }
if (!TimeOut)
 {
  for (n = 0; n < 190; n++)
   {
    if( Ver == 1 )
     if ( !(Buf[n] & 0x80) || (Buf[n + 1] & 0x80) ||
	  (Buf[n + 2] & 0x80) || (Buf[n + 3] & 0x80) ||
	  (Buf[n + 4] & 0x80) || (Buf[n + 5] & 0x80) ||
	  (Buf[n + 6] & 0x80) ) continue;
    if( Ver == 2 )
     if ( !(Buf[n] & 0x80) || (Buf[n + 1] & 0x80) ||
	   (Buf[n + 2] & 0x80) || (Buf[n + 3] & 0x80) ) continue;
    if( Ver == 1 )
     {
      P = (Buf[n] & 0x40) >> 6;
      k = (Buf[n] >> 3) & 3;
      AdChData = (Buf[n] & 0x7) | ((unsigned long) Buf[n + 1] << 3L) |
		   ((unsigned long) Buf[n + 2] << 10L) |
		   ((unsigned long) Buf[n + 3] << 17L);
      T = (Buf[n + 4]) | ((unsigned long) Buf[n + 5] << 7L) |
	  ((unsigned long) Buf[n + 6] << 14L);
     }
    if( Ver == 2 )
     {
      P = (Buf[n] & 0x40) >> 6;
      k = (Buf[n] >> 4) & 3;
      AdChData = ((unsigned long) ( Buf[n] & 0x0F) << 20L |
		  ((unsigned long) Buf[n + 1] << 13L) |
		  ((unsigned long) Buf[n + 2] << 6L) |
		  ((unsigned long) Buf[n + 3] >> 1L));
     }
      AdChData -= 0x800000;

      // Handle Loop Array for RMS calculations
    ChanData[k][ChanN[k]] = AdChData;
    ChanN[k]++;
    if (ChanN[k] >= N)
     {
      ChanN[k] = 0;
      ChanFirstN[k] = N;
     }
    if (ChanFirstN[k] < N)
     ChanFirstN[k]++;
    if (ChanFirstN[k] < 10)
     continue;
    f=CountRms(ChanData[k], ChanFirstN[k], &l);
    sprintf(cstr, "%8ld %1lu %6.1f", AdChData, P, f);
    SetCtrlVal(Pnl, BoxAddress[k], cstr);
    RmsArray[k]=f;
    if (k == 0)
     {
      SetCtrlVal(Pnl, TEST_MIN1, min);
      SetCtrlVal(Pnl, TEST_MAX1, max);
     }
   }
  SetCtrlVal(Pnl, TEST_TIMER, T);
  SetCtrlVal(Pnl, TEST_N, ChanFirstN[0]);
  if(ProgonOn)
   {
    t_new = time(NULL);
    if(t_new - t > ProgonPeriod)
     {
      sprintf(cstr, "⠭ 横 %lu, 訡 %lu", ++ProgonN,
	      Errors[0]+Errors[1]+Errors[2]+Errors[3]);
      SetCtrlVal(Pnl, TEST_STATUS, cstr);
      t=t_new;
      _dos_gettime(&t_start);
      fprintf(fp, "%2d:%02d  Rms1=%9.1f, Rms2=%9.1f, Rms3=%9.1f, Rms4=%9.1f\n",
		t_start.hour, t_start.minute, RmsArray[0], RmsArray[1],RmsArray[2],RmsArray[3]);
      for(i=0; i < 4; i++)
       {
	if(RmsArray[i] > MaxRms[i]) MaxRms[i]=RmsArray[i];
	if(RmsArray[i] > RmsLimit) Errors[i]++;
       }
      ZeroArrays();
     }
   }

	// Draw Char
	if(GraphOn && OldChanN[GraphChan] != ChanN[GraphChan])
		{
	  if(OldChanN[GraphChan] > ChanN[GraphChan])
			OldChanN[GraphChan]=0;
	  PlotStripChart (Pnl, TEST_STRIP,
				ChanData[GraphChan]+OldChanN[GraphChan],
				ChanN[GraphChan]-OldChanN[GraphChan], 0, 0, 2);
		OldChanN[n]=ChanN[n];
	  }
}
else
	SetCtrlVal(Pnl, TEST_STATUS, "㦥 Time Out");

}
int Diagnos_E24( void )
{
 int i, j, n, n1;

 sleep(1);
 disable();
 clear_aux();
 for (i = 0; i < 200; i++)
  {
   Buf[i] = GetCharWait();
   if (kbhit() || TimeOut) break;
  }
 enable();
 if (!TimeOut)
  {
   for (j = 0; j < 190; j++)
    if ((Buf[j] & 0x80) && !(Buf[j + 1] & 0x80) && !(Buf[j + 2] & 0x80))
	 break;
   if( j != 190 )
    for( n=j+1, n1=1; n<j+1+6; n++ )
     if( !(Buf[n] & 0x80) ) n1++;
     else break;
  }

 if( n1 == 7 )
  {
   Ver = 1;
   return(1);
  }
 if( n1 == 4 )
  {
   Ver = 2;
   return(1);
  }
 Ver = -1;
 return(0);
}